org.cpsolver.studentsct.model

## Class AreaClassificationMajor

- java.lang.Object
- - org.cpsolver.studentsct.model.AreaClassificationMajor

- All Implemented Interfaces:
    Comparable<AreaClassificationMajor>

      public class AreaClassificationMajor
      extends Object
      implements Comparable<AreaClassificationMajor>

  Academic area, classification, and major code. This class is used for `Student.getAreaClassificationMajors()`.
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AreaClassificationMajor(String area, String classification, String major)` Constructor
    `AreaClassificationMajor(String area, String classification, String major, String concentration)` Constructor
    `AreaClassificationMajor(String area, String classification, String major, String concentration, Double weight)` Constructor
    `AreaClassificationMajor(String areaCode, String areaName, String classificationCode, String classificationName, String majorCode, String majorName)` Constructor
    `AreaClassificationMajor(String areaCode, String areaName, String classificationCode, String classificationName, String majorCode, String majorName, String concentrationCode, String concentrationName)` Constructor
    `AreaClassificationMajor(String areaCode, String areaName, String classificationCode, String classificationName, String majorCode, String majorName, String concentrationCode, String concentrationName, Double weight)` Constructor
    `AreaClassificationMajor(String areaCode, String areaName, String classificationCode, String classificationName, String majorCode, String majorName, String concentrationCode, String concentrationName, String degreeCode, String degreeName, Double weight)` Constructor
    `AreaClassificationMajor(String areaCode, String areaName, String classificationCode, String classificationName, String majorCode, String majorName, String concentrationCode, String concentrationName, String degreeCode, String degreeName, String programCode, String programName, Double weight)` Constructor
    `AreaClassificationMajor(String areaCode, String areaName, String classificationCode, String classificationName, String majorCode, String majorName, String concentrationCode, String concentrationName, String degreeCode, String degreeName, String programCode, String programName, String campus, String campusName, Double weight)` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareTo(AreaClassificationMajor acm)`
    `boolean` | `equals(Object o)`
    `String` | `getArea()` Academic area
    `String` | `getAreaName()` Academic area name
    `String` | `getCampus()` Campus (optional)
    `String` | `getCampusName()` Campus (optional)
    `String` | `getClassification()` Academic classification
    `String` | `getClassificationName()` Academic classification name
    `String` | `getConcentration()` Concentration (optional)
    `String` | `getConcentrationName()` Concentration (optional)
    `String` | `getDegree()` Degree (optional)
    `String` | `getDegreeName()` Degree (optional)
    `String` | `getMajor()` Major
    `String` | `getMajorName()` Major name
    `String` | `getProgram()` Program (optional)
    `String` | `getProgramName()` Program (optional)
    `double` | `getWeight()` Weight (optional, defaults to 1.0)
    `int` | `hashCode()`
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AreaClassificationMajor

          public AreaClassificationMajor(String area,
                                         String classification,
                                         String major)

      Constructor
      Parameters:
        `area` - academic area
        `classification` - academic classification
        `major` - major

    - #### AreaClassificationMajor

          public AreaClassificationMajor(String area,
                                         String classification,
                                         String major,
                                         String concentration)

      Constructor
      Parameters:
        `area` - academic area
        `classification` - academic classification
        `major` - major
        `concentration` - concentration (optional)

    - #### AreaClassificationMajor

          public AreaClassificationMajor(String area,
                                         String classification,
                                         String major,
                                         String concentration,
                                         Double weight)

      Constructor
      Parameters:
        `area` - academic area
        `classification` - academic classification
        `major` - major
        `concentration` - concentration (optional)
        `weight` - weight (optional)

    - #### AreaClassificationMajor

          public AreaClassificationMajor(String areaCode,
                                         String areaName,
                                         String classificationCode,
                                         String classificationName,
                                         String majorCode,
                                         String majorName)

      Constructor
      Parameters:
        `areaCode` - academic area abbreviation
        `areaName` - academic area name
        `classificationCode` - academic classificationCode
        `classificationName` - academic classificationName
        `majorCode` - major code
        `majorName` - major name

    - #### AreaClassificationMajor

          public AreaClassificationMajor(String areaCode,
                                         String areaName,
                                         String classificationCode,
                                         String classificationName,
                                         String majorCode,
                                         String majorName,
                                         String concentrationCode,
                                         String concentrationName)

      Constructor
      Parameters:
        `areaCode` - academic area abbreviation
        `areaName` - academic area name
        `classificationCode` - academic classificationCode
        `classificationName` - academic classificationName
        `majorCode` - major code
        `majorName` - major name
        `concentrationCode` - concentration (optional)
        `concentrationName` - concentration (optional)

    - #### AreaClassificationMajor

          public AreaClassificationMajor(String areaCode,
                                         String areaName,
                                         String classificationCode,
                                         String classificationName,
                                         String majorCode,
                                         String majorName,
                                         String concentrationCode,
                                         String concentrationName,
                                         Double weight)

      Constructor
      Parameters:
        `areaCode` - academic area abbreviation
        `areaName` - academic area name
        `classificationCode` - academic classificationCode
        `classificationName` - academic classificationName
        `majorCode` - major code
        `majorName` - major name
        `concentrationCode` - concentration (optional)
        `concentrationName` - concentration (optional)
        `weight` - weight (optional)

    - #### AreaClassificationMajor

          public AreaClassificationMajor(String areaCode,
                                         String areaName,
                                         String classificationCode,
                                         String classificationName,
                                         String majorCode,
                                         String majorName,
                                         String concentrationCode,
                                         String concentrationName,
                                         String degreeCode,
                                         String degreeName,
                                         Double weight)

      Constructor
      Parameters:
        `areaCode` - academic area abbreviation
        `areaName` - academic area name
        `classificationCode` - academic classificationCode
        `classificationName` - academic classificationName
        `majorCode` - major code
        `majorName` - major name
        `concentrationCode` - concentration (optional)
        `concentrationName` - concentration (optional)
        `degreeCode` - degree (optional)
        `degreeName` - degree (optional)
        `weight` - weight (optional)

    - #### AreaClassificationMajor

          public AreaClassificationMajor(String areaCode,
                                         String areaName,
                                         String classificationCode,
                                         String classificationName,
                                         String majorCode,
                                         String majorName,
                                         String concentrationCode,
                                         String concentrationName,
                                         String degreeCode,
                                         String degreeName,
                                         String programCode,
                                         String programName,
                                         Double weight)

      Constructor
      Parameters:
        `areaCode` - academic area abbreviation
        `areaName` - academic area name
        `classificationCode` - academic classificationCode
        `classificationName` - academic classificationName
        `majorCode` - major code
        `majorName` - major name
        `concentrationCode` - concentration (optional)
        `concentrationName` - concentration (optional)
        `degreeCode` - degree (optional)
        `degreeName` - degree (optional)
        `programCode` - program (optional)
        `programName` - program (optional)
        `weight` - weight (optional)

    - #### AreaClassificationMajor

          public AreaClassificationMajor(String areaCode,
                                         String areaName,
                                         String classificationCode,
                                         String classificationName,
                                         String majorCode,
                                         String majorName,
                                         String concentrationCode,
                                         String concentrationName,
                                         String degreeCode,
                                         String degreeName,
                                         String programCode,
                                         String programName,
                                         String campus,
                                         String campusName,
                                         Double weight)

      Constructor
      Parameters:
        `areaCode` - academic area abbreviation
        `areaName` - academic area name
        `classificationCode` - academic classificationCode
        `classificationName` - academic classificationName
        `majorCode` - major code
        `majorName` - major name
        `concentrationCode` - concentration (optional)
        `concentrationName` - concentration (optional)
        `degreeCode` - degree (optional)
        `degreeName` - degree (optional)
        `programCode` - program (optional)
        `programName` - program (optional)
        `weight` - weight (optional)

  - ### Method Detail

    - #### getArea

          public String getArea()

      Academic area
      Returns:
        academic area abbreviation

    - #### getClassification

          public String getClassification()

      Academic classification
      Returns:
        classification code

    - #### getMajor

          public String getMajor()

      Major
      Returns:
        major code

    - #### getConcentration

          public String getConcentration()

      Concentration (optional)
      Returns:
        concentration code

    - #### getDegree

          public String getDegree()

      Degree (optional)
      Returns:
        degree code

    - #### getProgram

          public String getProgram()

      Program (optional)
      Returns:
        program code

    - #### getAreaName

          public String getAreaName()

      Academic area name
      Returns:
        academic area name

    - #### getClassificationName

          public String getClassificationName()

      Academic classification name
      Returns:
        classification name

    - #### getMajorName

          public String getMajorName()

      Major name
      Returns:
        major name

    - #### getConcentrationName

          public String getConcentrationName()

      Concentration (optional)
      Returns:
        concentration name

    - #### getDegreeName

          public String getDegreeName()

      Degree (optional)
      Returns:
        degree name

    - #### getProgramName

          public String getProgramName()

      Program (optional)
      Returns:
        program name

    - #### getCampus

          public String getCampus()

      Campus (optional)
      Returns:
        campus name

    - #### getCampusName

          public String getCampusName()

      Campus (optional)
      Returns:
        campus name

    - #### getWeight

          public double getWeight()

      Weight (optional, defaults to 1.0)

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### compareTo

          public int compareTo(AreaClassificationMajor acm)

      Specified by:
        `compareTo` in interface `Comparable<AreaClassificationMajor>`